/************************************************************************************/
/*  Program name CAPPOEXT_ORG_STRUCT_ELEMENT.sql                              */
/*  Creater:  CHAN BILLY KA KEUNG (PCCW - UniHub)                                   */
/*************   History   *************************                                */
/* 24 MAY 2006				       First created                                    */
/************************************************************************************/
SET VERIFY OFF;
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPPOEXT_ORG_STRUCT_ELEMENT';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPPO_ORG_STRUCT_ELEMENT.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT 
		A.*
	FROM   
		PER_ORG_STRUCTURE_ELEMENTS A,
		HR_ALL_ORGANIZATION_UNITS	HOU
	WHERE	A.BUSINESS_GROUP_ID		=	HOU.BUSINESS_GROUP_ID
	AND		NAME	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	NAME	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.ORG_STRUCTURE_ELEMENT_ID      ||CHR(9)||
				C1.BUSINESS_GROUP_ID             ||CHR(9)||
				C1.ORGANIZATION_ID_PARENT        ||CHR(9)||
				C1.ORG_STRUCTURE_VERSION_ID      ||CHR(9)||
				C1.ORGANIZATION_ID_CHILD         ||CHR(9)||
				C1.REQUEST_ID                    ||CHR(9)||
				C1.PROGRAM_APPLICATION_ID        ||CHR(9)||
				C1.PROGRAM_ID                    ||CHR(9)||
				C1.PROGRAM_UPDATE_DATE           ||CHR(9)||
				C1.LAST_UPDATE_DATE              ||CHR(9)||
				C1.LAST_UPDATED_BY               ||CHR(9)||
				C1.LAST_UPDATE_LOGIN             ||CHR(9)||
				C1.CREATED_BY                    ||CHR(9)||
				C1.CREATION_DATE                 ||CHR(9)||
				C1.OBJECT_VERSION_NUMBER         ||CHR(9)||
				C1.POSITION_CONTROL_ENABLED_FLAG ||CHR(9)||
				C1.PARTY_ID   
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/